'FFSubmenu=Rahmen
'FFName=Collage+

'FFSkriptName=Collage_Plus.vbs
'FFSkriptArchiv=Collage_Plus.zip
'FFSkriptDirectory=\MeckiScript\Collage+
'FFSkriptFiles=\MeckiScript\Collage+\Collage+.pdf
'FFScriptProfile=FF_Collage

'FFSkriptAuthor=Harald Maeckler
'FFSkriptVersion=3.27
'FFVersion=2.91.0
'FFSkriptURL=http://www.meckis-steckenpferde.de/FixFoto_Skripte.html

' ********************************************************************
' Collage_Plus.vbs (Script fr FixFoto)
' Weiterentwicklung des Skript Collage 1.6.vbs (Autor Lui 13.10.2006)
' von Harald Maeckler, Dsseldorf 2009
'
' Funktion:	Fgt mehrere Bilder zusammen und bildet einen Rahmen darum
' 			Eingabewerte:	Bilderhhe ab Version 3.0 alternativ Collagebreite,
'							Bildanordnung links, mittig oder rechts,
'							Zeilenanzahl, Rahmenbreite, Rahmenfarbe
' 			Ausgabe: 		Zusammengesetztes Bild
'
' Version 3.27 vom 29.03.2016	- Skript-URL gem Forenberarbeitung gendert
' Version 3.26 vom 05.04.2014	- Aktualisierung der Updatefunktion
'								- Fremdaufruf ermglicht ber die Zwischenablage (am 16.04. wieder entfernt)
'							    - mit Zusatzskript Profiler
' Version 3.25 vom 18.02.2012	- Mixfehler bei bestimmten Bildanordnungen wird abgefangen
' Version 3.24 vom 17.02.2012	- Aufruf durch AlbumMaker endgltig entfernt
'								- Auswahl erweitert um alle Bilder in Comp.- und Bilderansicht
'								- Anzeige Spalten- und Zeilenzahl jetzt 'nackt'
'								- Kurzbeschreibung nur noch als PDF, nur alternativ Text
'								- Update-Funktion hinzu
'								- Tooltips hinzugefgt
' Version 3.23 vom 16.09.2011	- Bug in der Geobilderzeugung beseitigt
' Version 3.22 vom 14.09.2011	- Bug in der Bildnummerierung beseitigt
' Version 3.21 vom 13.09.2011	- Bildfilter erweitert um .JPEG
' Version 3.20 vom 27.02.2011	- nach Geobild-Aufruf Auswertung von FF_GetParam = "GeoOK"
' Version 3.19 vom 26.02.2011	- Geobild-Abholung gendert,
'										dadurch muss bei Aufruf von 'Geobild' kein Bild mehr auf der Arbeitsflche geladen sein
' Version 3.18 vom 21.02.2011	- bei Aufruf 'Geobild' muss 1 Bild auf der Arb.Flsche geladen sein
'									Das wird jetzt kontrolliert
'								- Aufruf durch ein Fremdskript (z.B. AlbumMaker) ist mglich durch
'									bertragung des Pfads einer Bilderliste, die Bilder mit Geodaten
'									beinhaltet, getrennt durch CR+LF.
'									Aus diesen Bildern wird eine Collage erzeugt und dann Geobild
'									aufgerufen mit bertragung der Liste.
'									Nach Kombibilderzeugung erfolgt eine Rckmeldung an das aufrufende Skript.
' Version 3.17 vom 14.02.2011	- Bildnummerierung bei Aufruf 'Geobild' angepasst
' Version 3.16 vom 13.02.2011	- kleine Bereinigungen
'								- Bildnummerierung auch mit Grobuchstaben mglich (bis Z = 26)
'								- bei Option 'Geobild'
'									* ist jetzt die Anpassung des Geobilds
'										an die Gre der Collage per Rahmen whlbar
'									* wurde die Option 'Endrahmen' optimiert
' Version 3.15 vom 08.02.2011	- Anordnung der Collage zum Geobild whlbar
' Version 3.14 vom 08.02.2011	- Bugs beseitigt:
'									* Aufruf Geobild muss manuell aktiviert werden
'									* Hhenanpassung wenn Collage hher als Geobild korrigiert
'									* Parameter C1 fr Computeransicht und C2 fr Bilderliste
'										zur Abfrage fr das Skript 'Geobild' gesetzt
' Version 3.13 vom 07.02.2011	- Aufruf des Skript 'Geobild' hinzugefgt
' Version 3.12 vom 02.02.2011	- Spaltenzahl vorgebbar (daraus wird die Zeilenzahl berechnet)
'								- Fehleingabemglichkeiten verhindert
'								- Kurzbeschreibung als PDF aufrufbar
' Version 3.11 vom 31.01.2011	- Schriftparameter fr die Bildnummerierung nderbar
' Version 3.10 vom 30.01.2011	- Bildfilter eingebaut
' Version 3.09 vom 05.11.2010	- Nummerierung der Bilder eingebaut
' Version 3.08 vom 19.06.2010	- Formatierungsaufruf (Bildrand ab Version 2.07) korrigiert 
' Version 3.07 vom 11.09.2009	- aufgerumt und KB berarbeitet
' Version 3.06 vom 08.09.2009	- Vorgabe Collagebreite: Option "ohne Hhennormierung"
' Version 3.05 vom 02.09.2009	- Sonderroutine bei Zeilenanzahl 0
'								  Bilder werden untereinander ohne Grennderung angeordnet
' Version 3.04 vom 01.09.2009	- Berechn.Fehler bei Vorgabe Collagebreite beseitigt
' Version 3.03 vom 31.08.2009	- mglicherweise auftretenden Rahmenbug beseitigt
' Version 3.02 vom 30.08.2009	- Bug in der Bestimmung der Collagebreite beseitigt
' Version 3.01 vom 29.08.2009	- Absicherungen gegen Wertbereichsberschreitungen
' Version 3.00 vom 28.08.2009	- alternative Vorgabe zur Bilderhhe: Collagebreite
'								- Bildanordnung links, mittig oder rechts
' Version 2.04 vom 23.08.2009	- Bug im Skriptaufruf von 'Bildrand' beseitigt
' Version 2.03 vom 22.08.2009	- Option Formatierung ruft das Skript 'Bildrand' auf
' Version 2.02 vom 19.08.2009	- Bilder wahlweise in der Computeransicht oder 
'								  der aktuellen Bilderliste selektieren
' Version 2.01 vom 18.08.2009	- Kurzbeschreibung
' Version 2.00 vom 17.08.2009	- Neue Bedienoberflche
'								- Einstellungen in Registry speichern und bei
'									Neustart wieder herstellen
'								- Skript-Lschroutine
'
' Letzte Version von Lui
' 1.6: - Schalter fr Endrahmen eingebaut
' 1.5: - Kontrolle ob mindestens 1 Bild ausgewhlt
' 1.4: - Rundungsfehler korrigiert (Werte fr MixImage)
'
'** Start Kurzbeschreibung *******************************************
'
' Collage+ / Version 3.27
' ===============
' Die wahlweise in der Computeransicht oder in der aktuellen Bilderliste ausgewhlten Bilder
' werden zu einem Bild zusammengefgt. Dabei wird ein Rahmen um die einzelnen Bilder gelegt.
'
' Auswahl
' ----------
' Hier wird festgelegt, welche Bilder zu einer Collage zusammen gefgt werden.
' - alle Bilder der Computeransicht
' - selektierte Bilder der Computeransicht
' - alle Bilder der aktuellen Bilderliste
' - selektierte Bilder der aktuellen Bilderliste

' Die Bilderliste hat den Vorteil, dass dort Bilder aus verschiedenen Verzeichnissen zusammen-
' gestellt werden knnen. Auerdem ist eine beliebige Anordnung der Bilder durch manuelles
' Verschieben mit der Maus mglich.
'
' Bildverteilung
' ----------------
' Es kann gewhlt werden ob die Bilderhhe oder die Collagebreite vorgegeben wird. Bei Vorgabe
' der Collagebreite wird die zur Erreichung dieser Breite notwendige Bilderhhe berechnet. 
' Alle Bilder werden auf die erforderliche Bilderhhe skaliert, es sei denn die Option 
' 'ohne Hhennormierung' ist aktiviert. Auf jeden Fall werden die Bilder proportional zu ihrer
' Originalgre so angepasst, dass sich die die geforderte Collagebreite ergibt.
'
' Mit der Zeilenzahl wird festgelegt, auf wie viel Zeilen die Bilder verteilt werden. Ist die
' Anzahl der selektierten Bilder kleiner als die gewhlte Zeilenzahl, wird diese automatisch
' reduziert auf die Bilderanzahl. Die Spaltenzahl wird daraus berechnet.
'
' Mit der Spaltenzahl wird festgelegt, auf wie viel Spalten die Bilder ungefhr verteilt werden.
' Ist die Anzahl der selektierten Bilder kleiner als die gewhlte Spaltenzahl, wird diese auto-
' matisch reduziert auf die Bilderanzahl. Die Zeilenzahl wird daraus berechnet.
' Bei der Bildverteilung wird die Spaltenzahl im allgemeinen mit einer Toleranz von +/-1 einge-
' halten
'
' +++ Sonderfall +++
' Einen Sonderfall stellt die Vorgabe Zeilenzahl = 0 und Spaltenzahl = 0 dar:
' Dann werden alle ausgewhlten Bilder ohne Grennderung untereinander angeordnet, das heit
' die Vorgabe einer Bilderhhe bzw. Collagebreite ist bedeutungslos. Das breiteste Bild bestimmt
' die Collagebreite.
'
' Bildanordnung
' -----------------
' Fr die Zeilen, in denen die Bilder nicht die gesamte Collagebreite ausfllen, kann zwischen
' der Anordnung Links, Mitte und Rechts gewhlt werden.
'
' Rahmen
' ----------
' Rahmenbreite und Rahmenfarbe knnen beliebig definiert werden.
'
' Die Rahmenbreite kann auch 0 sein. Die Rahmenfarbe wird dann nur noch bei mehrzeiligen 
' Collagen zum Auffllen leerer Flchen benutzt. Dabei kann allerdings im Einzelfall ein Rand
' von 1 Pixel Breite entstehen, der bei einer greren Rahmenbreite nicht auffllt.
'
' Ob die fertige Collage einen Endrahmen erhlt, kann man frei bestimmen.
' Collagen ohne Endrahmen sind dann sinnvoll wenn man mehrere Teilcollagen erstellen und
' dann diese zu einer Gesamtcollage mit Endrahmen zusammen fgen will.
'
' Bildnummerierung
' ---------------------
' Ist diese Option aktiviert, werden alle Bilder der Collage fortlaufend von links nach rechts
' und dann von oben nach unten nummeriert.
'
' Wird der Aufruf 'Geobild' zustzlich gewhlt, wird von 1 - 9 nummeriert, gefolgt von Gro-
' buchstaben A - Z und dann fortgesetzt mit 10, 11 usw.
'
' Bettigt man die Taste 'Param' wird damit der Dialog zur Einstellung der Schriftparameter
' Lage, Schrifthhe, Schriftstrke, Schriftart und Schriftfarbe geffnet. 
' Dort kann auch die Option 'Grobuchstaben (A - Z ) statt Zahlen' aktiviert werden. Sind es
' mehr als 26 Bilder, wird die Nummerierung von A bis Z weitergefhrt mit 1, 2 usw.
'
' Aufrufe
' ---------
' Es knnen wahlweise die Skripte 'Bildrand' oder 'Geobild' aufgerufen werden. Beide Aufrufe
' zu aktivieren ist leider nicht zulssig, da es sonst zu einer Fehlermeldung 'Speichermangel'
' kommen kann.
'
' - 'Bildrand'
' Das Skript muss als Version >= 2.00 installiert sein, sonst erfolgt eine Warnmeldung.
'
' Um die erstellte Collage an ein Belichterformat anzupassen, wird bei aktivierter Option das
' Skript 'Bildrand' aufgerufen. Dort kann, vorausgesetzt ein Belichter ist implementiert, ein
' Format ausgesucht und die Collage entsprechend formatiert werden. Die eingestellte Randfarbe
' wird auf das Skript 'Bildrand' bertragen, kann dort aber gendert werden.
' 
' Empfehlungen:
' * Die Option 'Endrahmen' deaktivieren.
' * Im Skript 'Bildrand' zur Anpassung 'Randvergrerung' oder 'Verzerrung' whlen.
'
' - 'Geobild'
' Das Skript muss installiert sein, und es ist mindestens FixFoto-Version 3.10.2 erforderlich, 
' sonst erfolgt eine Warnmeldung.
'
' Um 'Geobild' ausfhren zu knnen, muss mindestens ein Bild mit Geodaten in den Exif-Daten
' ausgewhlt sein. Nach Erstellung der Collage wird das Skript 'Geobild' aktiviert. Nach Abschluss
' des Skript mit 'bergeben & Beenden' wird abgefragt
'	* auf welcher Geobildseite die Collage angefgt werden soll (Links, Rechts, Oben oder Unten)
'	* ob die Geobildgre durch Rahmenerweiterung an die Collagegre angepasst werden soll,
'	   falls die Collage grer ist als das Collagebild.
'	   Ist diese Option nicht aktiviert, wird die Collage ggf. durch Skalierung an die Geobildgre
'	   angepasst.
' Achtung: Bei Geobild darf auf keinen Fall die Taste 'ZwAb' benutzt werden.
'
' Empfehlungen:
' * Im Collage-Skript die Option 'Bildnummerierung' aktivieren
' * Im Geobild-Skript 'Markierung' und 'fortlaufend nummerieren' aktivieren.
' So erhlt man eine Zuordnung der Markierungen zu den angefgten Bildern.
' Auerdem ist es sinnvoll, im Collage-Skript zuerst die Option 'Geobild' aktivieren und dann Zeilen-
' und Spaltenzahl festzulegen
'
' Anmerkung
' =======
' Es gibt Konstellationen, bei denen es nicht mglich ist, die Bilder auf die gewhlte Zeilenzahl
' richtig zu verteilen; eine Zeile ist dann leer. Leider ist dieses Problem bisher nicht gelst.
' Bei Auftreten dieses Phnomens wird empfohlen die Zeilenzahl um 1 zu verringern.
'
' Deinstallation
' ========
' Wird die Entfernung des Skripts gewnscht, kann mit der Tastenkombination Alt + D eine 
' Lschroutine aufgerufen werden. Nach einer Sicherheitsabfrage wird berprft, ob das 
' zugehrige zip-Archiv im Skriptordner abgelegt ist. Wenn ja, wird vor dem Lschen angeboten,
' davon eine Sicherheitskopie an einem beliebigen Speicherort abzulegen. Danach werden nach-
' einander die Skriptdatei, die in der Registry dazugehrenden Daten und eventuelle Zusatz-
' dateien gelscht. Abschlieend wird die FixFotoScript.ini bereinigt.
' Nach manueller Durchfhrung einer 'Automatischen Skriptkonfiguration' ist das Skript mit 
' allen Komponenten aus der FixFoto-Umgebung entfernt.
'
'
' Benutzung des Skripts auf eigene Gefahr!
'
' Script by Lui bis Version 1.6
' Weiterentwicklung Harald Maeckler, Dsseldorf ab Version 2.0
'
'** Ende Kurzbeschreibung ********************************************

Option Explicit
'---------------------------------------------------------------------
'Updatekonstanten und Variable
const SkriptVersion = "3.27"
const SkriptURL = "http://www.ffsf.de/resources/collage.145/"
Dim UrlVersion,UrlV_Zahl,SkriptV_Zahl,SkriptEnde
'---------------------------------------------------------------------
'Nachschrfen beim Geobild
const RGB_S = true	'RGB-Schrfe
const Y_S = false	'Y-Schrfe
const Schaerfe = 20
'---------------------------------------------------------------------
'Nummerierungsparameter
const s_NummXminus  = 10		'Abstand des Textendes vom rechten Rand [px]
const s_NummYminus  = 10		'Abstand der Textgrundlinie vom unteren Rand [px]
const s_NummHoehe   =	40		'Schrifthhe [px]
const s_NummStaerke =	400		'Schriftstrke (1-1000; 400=normal)
const s_NummSchrift = "Arial"	'Schriftart
const s_NummFarbe_string = "255 000 000"
const s_flagBuchstaben	 = 0
Dim NummXminus,NummYminus,NummHoehe,NummStaerke,NummSchrift,NummFarbe,NummFarbe_string,NummFarbe_Array,flagBuchstaben
'---------------------------------------------------------------------
const Bildfilter = ".JPG.JP2.PNG.TIF.BMP.JPEG"
Dim imagenum,FileArray,flagCompAnsicht_All,flagCompAnsicht,flagAktListe_All,flagAktListe
Dim flagBH,flagCB,flagOHN,y_row
Dim flagLinks,flagMitte,flagRechts,Anordnung
Dim rows,rahmen,Farbe,FarbWert,color,Endrahmen,columns
Dim flagNumm,flagFormat,Aufruf,Fremdaufruf
Dim Anzeige
Dim flagGPS,C_Anordnung,flagGeoAnpassung,FileOhneGPSold
const CzuG = "Links/Rechts/Oben/Unten"
'---------------------------------------------------------------------
const SkriptName = "Collage_Plus.vbs"		'Skriptname
const RegSchluessel = "FF_Collage"			'Registryschlssel

Dim Kurzbeschreibung, KBvorhanden, LaengeMax, Abbruch		'Kurzbeschreibung
const ForReading = 1, ForWriting = 2, ForAppending = 8

Dim SkriptKill,Antwort,TempFile								'Lschroutine

Dim objFS,WshShell											'Objekte

Abbruch = false : Fremdaufruf = false
'---------------------------------------------------------------------
call main

if not Abbruch and flagGPS = 1 then						'Aufruf des Skript 'Geobild'
	if objFS.FileExists(FF_GetScriptPath & "\geobild.vbs") then
		if Version_OK("3.10.6") then
			call Geo_Routine
		else
			msgbox 	"Fr den Aufruf von 'Geobild'" & vbNewLine & _
					"ist mindesten FixFoto-Version 3.10.6 erforderlich.",vbExclamation,"Hinweis"
		end if
	else
		msgbox 	"Das Skript 'Geobild' ist erforderlich." & vbNewLine & _
				"Bitte die Installation berprfen!" & vbNewLine & _
				"Evtl. muss das Skript 'Geobild' einmal gestartet werden.",vbExclamation,"Hinweis"
	end if
end if

if not Abbruch and Fremdaufruf then						'Aufruf des Skript 'Bildformat' zur Formatierung
	Dim SkriptBildrand
	SkriptBildrand = FF_GetScriptPath & "\Bildrand.vbs"
	if objFS.FileExists(SkriptBildrand) and FF_GetProfile("FF_Bildrand","isCollage") <> "" then
		FF_WriteProfile "FF_Bildrand","FarbFaktor",Farbe
		FF_WriteProfile "FF_Bildrand","Auswahl",4
		FF_WriteProfile "FF_Bildrand","isCollage",1
		FF_CallScript SkriptBildrand
	else
		msgbox 	"Zur Formatierung ist das Skript 'Bildrand' ab Version 2.07 erforderlich." & vbNewLine & _
				"Bitte die Installation bzw. die Version berprfen!" & vbNewLine & _
				"Evtl. muss das Skript 'Bildrand' einmal gestartet werden.",vbExclamation,"Hinweis"
	end if
end if

'---------------------------------------------------------------------
Sub main

Set objFS = CreateObject("Scripting.FileSystemObject")
Set WshShell = CreateObject("WScript.Shell")

on error resume next									'Kontrolle ob Skript in FF-Umgebung gestartet wurde
	imagenum = FF_GetImageCount
 	if Err.Number > 0 then
		msgbox "Das Skript funktioniert nur in der Programmumgebung von FixFoto!",vbCritical,"Abbruch"
		exit sub
	end if
on error goto 0

'** Start Dialog Collage+ **
FF_AddDialog "Collage+",198,160
FF_AddControl "Collage+","Auswahl","GROUP",6,5,92,50
FF_AddControl "Collage+","flagCompAnsicht","BOOL",13,24,8,8
FF_SetControlStyle "Collage+","flagCompAnsicht",16384
FF_AddControl "Collage+","selekt. Bilder der Comp.-Ans.","STATIC",24,23,72,10
FF_AddControl "Collage+","flagAktListe","BOOL",13,43,8,8
FF_SetControlStyle "Collage+","flagAktListe",16384
FF_AddControl "Collage+","selekt. Bilder der akt. Bilderl.","STATIC",24,42,72,10
FF_AddControl "Collage+","Bildverteilung","GROUP",6,56,92,72
FF_AddControl "Collage+","flagBH","BOOL",13,69,8,8
FF_SetControlStyle "Collage+","flagBH",16384
FF_AddControl "Collage+","Bilderhhe","STATIC",23,68,34,10
FF_AddControl "Collage+","flagCB","BOOL",13,79,8,8
FF_SetControlStyle "Collage+","flagCB",16384
FF_AddControl "Collage+","Collagebreite","STATIC",23,78,34,10
FF_AddControl "Collage+","y_row","SLEDIT",60,72,25,10
FF_SetControlStyle "Collage+","y_row",8193
FF_AddControl "Collage+","px","STATIC",87,72,9,10
FF_AddControl "Collage+","flagOHN","BOOL",23,89,8,8
FF_SetControlStyle "Collage+","flagOHN",16384
FF_AddControl "Collage+","ohne Hhennormierung","STATIC",34,88,58,10
FF_AddControl "Collage+","Zeilenzahl","BUTTON",21,100,33,11
FF_AddControl "Collage+","Spaltenzahl","BUTTON",21,114,33,11
FF_AddControl "Collage+","ca.","STATIC",62,115,10,10
FF_AddControl "Collage+","Rahmen","GROUP",104,5,86,50
FF_AddControl "Collage+","Breite","STATIC",110,15,34,10
FF_AddControl "Collage+","rahmen","SLEDIT",147,17,27,10
FF_SetControlStyle "Collage+","rahmen",8193
FF_AddControl "Collage+","px|","STATIC",176,15,10,10
FF_AddControl "Collage+","color","COLOR",146,28,37,12
FF_AddControl "Collage+","Farbe","STATIC",110,29,34,10
FF_AddControl "Collage+","Endrahmen","BOOL",122,43,8,8
FF_AddControl "Collage+","Endrahmen|","STATIC",134,42,34,10
FF_AddControl "Collage+","Bildanordnung","GROUP",104,56,86,26
FF_AddControl "Collage+","flagLinks","BOOL",122,69,8,8
FF_SetControlStyle "Collage+","flagLinks",16384
FF_AddControl "Collage+","Links","STATIC",108,68,13,10
FF_SetControlStyle "Collage+","Links",1
FF_AddControl "Collage+","flagMitte","BOOL",148,69,8,8
FF_SetControlStyle "Collage+","flagMitte",16384
FF_AddControl "Collage+","Mitte","STATIC",134,68,13,10
FF_SetControlStyle "Collage+","Mitte",1
FF_AddControl "Collage+","flagRechts","BOOL",178,69,8,8
FF_SetControlStyle "Collage+","flagRechts",16384
FF_AddControl "Collage+","Rechts","STATIC",159,68,18,10
FF_SetControlStyle "Collage+","Rechts",1
FF_AddControl "Collage+","Aufrufe","GROUP",104,84,86,26
FF_AddControl "Collage+","flagFormat","BOOL",148,97,8,8
FF_SetControlStyle "Collage+","flagFormat",16384
FF_AddControl "Collage+","Bildrand","STATIC",159,96,22,10
FF_AddControl "Collage+","flagGPS","BOOL",111,97,8,8
FF_SetControlStyle "Collage+","flagGPS",16384
FF_AddControl "Collage+","Geobild","STATIC",121,96,22,10
FF_AddControl "Collage+","flagNumm","BOOL",111,116,8,8
FF_AddControl "Collage+","Bildnummerierung","STATIC",122,115,43,10
FF_AddControl "Collage+","Param","BUTTON",167,114,20,11
FF_AddControl "Collage+","Fortschritt","PROGRESS",6,133,184,6
FF_AddControl "Collage+","?","BUTTON",12,144,11,11
FF_AddControl "Collage+","Start","BUTTON",150,144,36,11
FF_AddControl "Collage+","&d","BUTTON",3,4,1,1
FF_AddControl "Collage+","|","STATIC",76,101,10,10
FF_SetControlStyle "Collage+","|",1
FF_AddControl "Collage+","||","STATIC",76,115,10,10
FF_SetControlStyle "Collage+","||",1
FF_AddControl "Collage+","flagCompAnsicht_All","BOOL",13,14,8,8
FF_SetControlStyle "Collage+","flagCompAnsicht_All",16384
FF_AddControl "Collage+","flagAktListe_All","BOOL",13,33,8,8
FF_SetControlStyle "Collage+","flagAktListe_All",16384
FF_AddControl "Collage+","alle Bilder der Comp.-Ansicht","STATIC",24,13,72,10
FF_AddControl "Collage+","alle Bilder der akt. Bilderliste","STATIC",24,32,72,10
FF_AddControl "Collage+","Update","BUTTON",53,144,33,11
FF_AddControl "Collage+","|||","STATIC",26,144,24,11
FF_SetControlStyle "Collage+","|||",1
'** End Dialog Collage+ **

call RegistryLesen

'Tooltips
if Version_OK("3.30.06") then
	FF_SetControlTooltip "Collage+","?", "" &_
						 "Anzeige der Kurzbeschreibung als PDF-Datei," & vbNewLine & "vorausgesetzt es ist ein PDF-Reader installiert."
	FF_SetControlTooltip "Collage+","|||","Skriptversion"
	FF_SetControlTooltip "Collage+","Update", "" &_
						 "Prfung ob eine neue Version vorliegt."
end if

'Selektierte Bilder ermitteln
call Bilderanzahl

if rows > imagenum then	rows = imagenum

if rows = 0 or imagenum = 0 then
	columns = 0
else
	columns = imagenum \ rows
end if

FF_ActivateControl "Collage+","&d"
FF_SetDialogTimer "Collage+", 100

do
	Select Case FF_ShowDialog ("Collage+")
	Case "TIMER"
		FF_SetControl "Collage+","|",rows
		FF_SetControl "Collage+","||",columns
		FF_SetControl "Collage+","|||","V " & SkriptVersion
		FF_SetDialogTimer "Collage+",0
	Case "Update"
		SkriptEnde = false
		call Update
		if SkriptEnde then exit do
	Case "flagCompAnsicht_All"
		FF_SetControl "Collage+","flagCompAnsicht_All",1
		FF_SetControl "Collage+","flagCompAnsicht",0
		FF_SetControl "Collage+","flagAktListe_All",0
		FF_SetControl "Collage+","flagAktListe",0
		flagCompAnsicht_All = 1 : flagCompAnsicht = 0
		flagAktListe_All = 0	: flagAktListe = 0
		call Bilderanzahl
	Case "flagCompAnsicht"
		FF_SetControl "Collage+","flagCompAnsicht_All",0
		FF_SetControl "Collage+","flagCompAnsicht",1
		FF_SetControl "Collage+","flagAktListe_All",0
		FF_SetControl "Collage+","flagAktListe",0
		flagCompAnsicht_All = 0 : flagCompAnsicht = 1
		flagAktListe_All = 0	: flagAktListe = 0
		call Bilderanzahl
	Case "flagAktListe_All"
		FF_SetControl "Collage+","flagCompAnsicht_All",0
		FF_SetControl "Collage+","flagCompAnsicht",0
		FF_SetControl "Collage+","flagAktListe_All",1
		FF_SetControl "Collage+","flagAktListe",0
		flagCompAnsicht_All = 0 : flagCompAnsicht = 0
		flagAktListe_All = 1	: flagAktListe = 0
		call Bilderanzahl
	Case "flagAktListe"
		FF_SetControl "Collage+","flagCompAnsicht_All",0
		FF_SetControl "Collage+","flagCompAnsicht",0
		FF_SetControl "Collage+","flagAktListe_All",0
		FF_SetControl "Collage+","flagAktListe",1
		flagCompAnsicht_All = 0 : flagCompAnsicht = 0
		flagAktListe_All = 0	: flagAktListe = 1
		call Bilderanzahl
	Case "flagBH"
		FF_SetControl "Collage+","flagBH",1
		FF_SetControl "Collage+","flagCB",0
		FF_SetControl "Collage+","flagOHN",0
	Case "flagCB"
		FF_SetControl "Collage+","flagBH",0
		FF_SetControl "Collage+","flagCB",1
	Case "flagOHN"
		if FF_GetControl("Collage+","flagOHN") = 1 then
			FF_SetControl "Collage+","flagBH",0
			FF_SetControl "Collage+","flagCB",1
		end if
	Case "Zeilenzahl"
		call Bilderanzahl
		if Abbruch then
			msgbox "Es ist kein Bild markiert!",vbInformation,"Hinweis"
		else
			do
				rows = InputBox("Zeilenzahl","Eingabe")
				if IsNumeric(rows) then
					rows = rows *1
					if rows > imagenum then rows = imagenum
						FF_SetControl "Collage+","|",rows
					exit do
				else
					msgbox "Es muss eine Zahl eingegeben werden!",vbInformation,"Hinweis"
				end if
			loop
			if rows = 0 then
				columns = 0
			else
				columns = imagenum \ rows
			end if
			FF_SetControl "Collage+","||",columns
		end if
	Case "Spaltenzahl"
		call Bilderanzahl
		if Abbruch then
			msgbox "Es ist kein Bild markiert!",vbInformation,"Hinweis"
		else
			do
				columns = InputBox("Spaltenzahl","Eingabe")
				if IsNumeric(columns) then
					columns = columns *1
					if columns > imagenum then columns = imagenum
					FF_SetControl "Collage+","||",columns
					exit do
				else
					msgbox "Es muss eine Zahl eingegeben werden!",vbInformation,"Hinweis"
				end if
			loop
			if columns = 0 then
				rows = 0
			else
				rows = imagenum \ columns
			end if
			FF_SetControl "Collage+","|",rows
		end if
	Case "flagLinks"
		FF_SetControl "Collage+","flagLinks",1
		FF_SetControl "Collage+","flagMitte",0
		FF_SetControl "Collage+","flagRechts",0
	Case "flagMitte"
		FF_SetControl "Collage+","flagLinks",0
		FF_SetControl "Collage+","flagMitte",1
		FF_SetControl "Collage+","flagRechts",0
	Case "flagRechts"
		FF_SetControl "Collage+","flagLinks",0
		FF_SetControl "Collage+","flagMitte",0
		FF_SetControl "Collage+","flagRechts",1
	Case "flagFormat"
		if FF_GetControl("Collage+","flagFormat") = 1 then
			FF_SetControl "Collage+","flagGPS",0
		end if
	Case "flagGPS"
		if FF_GetControl("Collage+","flagGPS") = 1 then
			FF_SetControl "Collage+","flagFormat",0
			flagGPS = 1
		else
			flagGPS = 0
		end if
		
		if not Abbruch then
			FileOhneGPSold = ""
			call Bilderanzahl
			if rows > imagenum then
				rows = imagenum
				FF_SetControl "Collage+","|",rows
			end if

			if rows = 0 or imagenum = 0 then
				columns = 0
			else
				columns = imagenum \ rows
			end if
			FF_SetControl "Collage+","||",columns
		end if
	Case "Param"
		call Schriftparameter
	Case "&d"
		Abbruch = false
		SkriptKill = false
		Antwort = msgbox("Soll das Skript " & SkriptName & vbNewline & _
						 "mit allen dazugehrigen Komponenten wirklich gelscht werden?", _
						 vbYesNo + vbQuestion,"Sicherheitsabfrage")
		if Antwort = vbYes then
			SkriptKill = true
			exit do
		end if
	Case "?"
		'FF_SetControl "Collage+","Fortschritt",65	'############## nur fr Screenshot
		Anzeige = """" & FF_GetScriptPath & "\MeckiScript\Collage+\Collage+.pdf" & """"
		on error resume next
		WshShell.Run Anzeige,1,false
		if err <> 0 then
			msgbox "Die Kurzbeschreibung konnte nicht als PDF-Datei geffnet werden." & vbNewLine & _
				   "Die Datei ist gelscht oder es ist kein PDF-Reader installiert (?)." & vbNewLine & vbNewLine &_
				   "Ersatzweise erfolgt eine Textanzeige!",vbExclamation,"Hinweis"
			err.clear
			
			if not KBvorhanden then	call KurzbeschreibungLesen
			if KBvorhanden then
				call KurzbeschreibungAnzeigen
			else
				msgbox "Keine Kurzbeschreibung gefunden!",vbExclamation,"Meldung"
			end if
			
		end if
		on error GoTo 0
	Case "Start"
		Abbruch = false
		call WerteAuslesen
		call Bilderanzahl
		if Abbruch then
			msgbox "Es ist kein geeignetes Bild vorhanden bzw. markiert!",vbCritical,"Abbruch"
			exit do
		end if
		if flagFormat = 1 and FF_GetImageWidth = 0 then
			msgbox 	"Wenn die Collage formatiert werden soll," & vbNewLine & _
					"muss in die Arbeitsflche irgendein Bild geladen sein!",vbCritical,"Hinweis"
			exit do
		end if
		call Kontrolle

		if not Abbruch then
			 select case Aufruf
				case "sonderNull"			'alle Bilder untereinander ohne Grennderung
					call SonderCollage(false)
				case "sonderRgleichI"		'alle Bilder proportional untereinander mit Anpassung an Collagebreite
					call SonderCollage(true)
				case "normalColl"			'Collage mit Vorgabe Collagebreite mit Hhennormierung
					call Collage
				case "ohneHnColl"			'Collage mit Vorgabe Collagebreite ohne Hhennormierung
					call Collage_oHN
			case else
			end select
			
			if not Abbruch then
				if flagGPS = 0 then FF_Reload
				if flagFormat = 1 then Fremdaufruf = true
			end if
			
			exit do
		end if
	Case "CANCEL"
		Abbruch = true
		exit do
	Case Else
	End Select
loop

call RegistrySchreiben
FF_CloseDialog ("Collage+")
if SkriptKill then call KillSkript	'ggf. Skript komplett entfernen

End Sub
'---------------------------------------------------------------------
Sub WerteAuslesen

flagCompAnsicht_All = FF_GetControl("Collage+","flagCompAnsicht_All")	'alle Bilder der Comp.-Ans.
flagCompAnsicht = FF_GetControl("Collage+","flagCompAnsicht")			'sel. Bilder der Comp.-Ans.
flagAktListe_All = FF_GetControl("Collage+","flagAktListe_All")			'alle Bilder der akt. Bilderl.
flagAktListe = FF_GetControl("Collage+","flagAktListe")					'sel. Bilder der akt. Bilderl.

flagBH = FF_GetControl("Collage+","flagBH")		'Vorgabe: 0 = Collagebreite / 1 = Bilderhhe
flagOHN = FF_GetControl("Collage+","flagOHN")	'Vorgabe Collagebreite ohne Hhennormierung
y_row =	FF_GetControl("Collage+","y_row")		'Bilderhhe (px) bzw. Collagebreite (px)
	if y_row = "" then y_row = 0
	y_row = y_row *1
rows =	FF_GetControl("Collage+","|") * 1	'Zeilenanzahl

if FF_GetControl("Collage+","flagLinks") = "1"  then Anordnung = "Links"
if FF_GetControl("Collage+","flagMitte") = "1"  then Anordnung = "Mitte"
if FF_GetControl("Collage+","flagRechts") = "1" then Anordnung = "Rechts"

rahmen = FF_GetControl("Collage+","rahmen")			'Rahmenbreite (px)
	if rahmen = "" then rahmen = 0
	rahmen = rahmen *1
Farbe =  FF_GetControl("Collage+","color")			'Rahmenfarbe
FarbWert = split(Farbe," ")
color = FarbWert(0) + FarbWert(1) * (2^8) + FarbWert(2) * (2^16)

Endrahmen  = FF_GetControl("Collage+","Endrahmen")	'Endrahmen
flagNumm   = FF_GetControl("Collage+","flagNumm")	'Bildnummerierung
flagFormat = FF_GetControl("Collage+","flagFormat")	'Skriptaufruf 'Bildrand'

flagGPS = FF_GetControl("Collage+","flagGPS")

End Sub
'---------------------------------------------------------------------
Sub Kontrolle

if rows > imagenum then
	rows = imagenum
	FF_SetControl "Collage+","|",rows
end if

if rows = 0 then
	Antwort = msgbox   ("Zeilenanzahl = 0 ist ein Sonderfall:" & vbNewLine & vbNewLine & _
						"Alle ausgewhlten Bilder werden ohne Grennderung untereinander angeordnet." & vbNewLine & _
						"Die Collagebreite entspricht dabei dem breitesten Bild plus ggf. Endrahmenbreite.",vbOkCancel + vbInformation,"Hinweis")
	if Antwort = vbCancel then
		Abbruch = true
		exit sub
	end if
end if

if y_row < 10 and rows > 0 then
	msgbox "Die Bilderhhe bzw. Collagebreite muss mindestens 10 px gro sein!",vbExclamation,"Hinweis"
	Abbruch = true
	exit sub
end if

'Aufruf definieren
if rows = 0 then
	Aufruf = "sonderNull"
elseif (rows = imagenum) and (flagOHN = 1) then
	Aufruf = "sonderRgleichI"
elseif flagOHN = 0 then
	Aufruf = "normalColl"
elseif flagOHN = 1 then
	Aufruf = "ohneHnColl"
else
	msgbox "Aufruffehler!",vbExclamation,"Abbruch"
end if

'Geobildaufruf nur mit selektierten Bildern
if flagGPS = 1 then
	if flagCompAnsicht = 0 and flagAktListe = 0 then
		msgbox "Ein Geobildaufruf ist nur mit der Auswahl selektierter Bilder mglich!",vbInformation,"Hinweis"
		Abbruch = true
		exit sub
	end if
end if

End Sub
'---------------------------------------------------------------------
Sub Collage
'Algorithmus zur Ermittlung der Collagebreite nach Version 1.6 by Lui
'Vereinfacht und dann ergnzt ab Version 2.00 by Harald Maeckler

Dim x,OK,rows_test,x_row,i,col
Dim x_Breite,y_Hoehe
Dim AnzR,Anzahl,Breite_Test,Hoehe_Test
Dim xStart,yStart,BildB,BildH
Dim n,Diff,Kx,Ky,MaxBreite
Dim Xarray() : Redim Xarray(imagenum)
Dim Row() : Redim Row(imagenum + 1)

'Collagebreite ermitteln

if flagBH = 1 then Breite_Test = y_row else Breite_Test = 1000	'Vorgabe: 0 = Collagebreite / 1 = Bilderhhe

for i = 0 to imagenum -1
	x = Breite_Test * FF_GetImageFileWidth(FileArray(i)) / FF_GetImageFileHeight(FileArray(i))
	Xarray(i) = x
	if x > x_Breite then x_Breite = x
	row(i+1) = i
next
AnzR = 0

if rows < imagenum then
	x_Breite = 	Breite_Test
	do 
		OK = true
		x_row = 0
		i = 0
		rows_test = 0

		do 
			rows_test = rows_test + 1
			x_row = 0
			
			do
				x_row = x_row + Xarray(i)
				i = i + 1
			loop until (x_row + Xarray(i) >= x_Breite or i = imagenum)
			
			if (x_row + Xarray(i)) = x_Breite then 
				Row(rows_test) = i
			else 
				Row(rows_test) = i - 1
			end if
			
		loop until i = imagenum
	
		if int(rows_test) > int(rows) then
			OK = false 
			x_Breite= x_Breite + 1
		end if
	loop until OK

	'Breite kontrollieren und ggf. korrigieren
	i = 0 : col = 1 : Kx = 0 : MaxBreite = 0 : AnzR = 0
	do while i < imagenum
		'Breitentest, ggf. Korektur x
		n = i :	BildB = 0 : Anzahl = 0
		do while n < Row(col) + 1
			BildB =  BildB + Breite_Test * FF_GetImageFileWidth(FileArray(n)) / FF_GetImageFileHeight(FileArray(n))
			if BildB >= MaxBreite then 
				AnzR = Anzahl
				MaxBreite = BildB
			end if
			n = n + 1
			Anzahl = Anzahl + 1
		loop
		Diff = x_Breite - BildB
		if Diff < 0 then
			if abs(Diff) > Kx then Kx = abs(Diff)
		end if
		i = Row(col) + 1
		col = col + 1
	loop
end if
x_Breite = x_Breite + Kx

'Collagegre bestimmen
if flagBH = 1 then							'Bildhhe ist vorgegeben / Collagebreite wird berechnet
	Hoehe_Test = y_row
	x_Breite = x_Breite + AnzR * rahmen
else										'Collagebreite ist vorgegeben / Bildhhe wird berechnet
	if Endrahmen = 1 and flagGPS = 0 then
		Hoehe_Test = (y_row - (AnzR + 2) * rahmen) / x_Breite * 1000
		x_Breite = y_row - 2 * rahmen
	else
		Hoehe_Test = (y_row - AnzR * rahmen) / x_Breite * 1000
		x_Breite = y_row
	end if
end if

y_Hoehe = (rows * Hoehe_Test) + (rows -1) * rahmen
if rows = 1 then Ky = 0 else Ky = .5

'Msgbox "Collagebreite = " & x_Breite & " / Collagehhe = " & y_Hoehe
call NeuesBild (x_Breite + .5,Y_Hoehe +Ky)

'Bilder einfgen
BildH = Hoehe_Test
i = 0 : col = 1
do while i < imagenum

	'Anordnung links, mittig oder rechts
	n = i :	BildB = 0
	do while n < Row(col) + 1
		BildB =  BildB + Hoehe_Test * FF_GetImageFileWidth(FileArray(n)) / FF_GetImageFileHeight(FileArray(n)) + rahmen
		n = n + 1
	loop
	Diff = x_Breite - BildB + rahmen

	select case Anordnung
		Case "Links"
			xStart = 0
		Case "Mitte"
			xStart = Diff / 2
		Case "Rechts"
			xStart = Diff
	case else
	end select
	
	'Bild einfgen
	do while i < Row(col) + 1
		FF_LoadImage FileArray(i)

		yStart = (col-1) * (Hoehe_Test + rahmen)
		BildB =  Hoehe_Test * FF_GetImageWidth / FF_GetImageHeight

'		Msgbox 	"Collagebreite = " & x_Breite & " / Collagehhe = " & y_Hoehe & " / Bild = " & i+1 & vbNewline & _
'				"Startx = " & xStart & " / Starty = " & yStart & " / B-Breite = " & BildB & " / B-Hhe = " & BildH
		
		'Hhentest, ggf Korrektur y
		Ky = y_Hoehe - yStart - BildH
		if Ky < 0 then
			Ky = round(abs(Ky) + .5)
			BildH = BildH - Ky
		end if
		
		if flagNumm = 1 then call Nummerierung (i,BildB,BildH)
		
on error resume next
		FF_Miximage xStart,yStart,BildB,BildH,255
		if err.number > 0 then
			msgbox	"Diese Bilderanordnung funktioniert leider nicht." & vbNewLine & _
					"Bitte ndern und dann nochmal versuchen!",vbCritical,"Abbruch"
			Abbruch = true
			exit sub
		end if
on error goto 0

		xStart = xStart + BildB + rahmen
		FF_SetControl "Collage+","Fortschritt",(i+1)/imagenum * 100
		i = i + 1
	loop
	col = col + 1
loop

'Collage anzeigen
FF_PopImage

'Endrahmen
if Endrahmen and flagGPS = 0 then FF_ExtendCanvas rahmen,rahmen,rahmen,rahmen,FarbWert(0),FarbWert(1),FarbWert(2)

End Sub
'---------------------------------------------------------------------
Sub Collage_oHN
Dim x,OK,rows_test,x_row,i,col
Dim x_Breite,y_Hoehe
Dim AnzR,Anzahl,Breite_Test,Hoehe_Test
Dim xStart,yStart,BildB,BildH
Dim n,Diff,Kx,Ky,MaxBreite
Dim Xarray() : Redim Xarray(imagenum)
Dim Row() : Redim Row(imagenum + 1,1)
Dim Faktor,x_max,MaxHoehe

'Bildbreiten eintragen und grte Breite ermitteln

for i = 0 to imagenum -1
	x = FF_GetImageFileWidth(FileArray(i))
	Xarray(i) = x
	if x > x_max then x_max = x		'x = Breite des breitesten Bildes
next

AnzR = 0
x_Breite = 	x_max
do 
	OK = true
	x_row = 0
	i = 0
	rows_test = 0
	do 
		rows_test = rows_test + 1
		x_row = 0
		do
			x_row = x_row + Xarray(i) 
			i = i + 1
		loop until (x_row + Xarray(i) > x_Breite or i = imagenum)
		if (x_row + Xarray(i)) = x_Breite and i < imagenum then
			Row(rows_test,0) = i
		else 
			Row(rows_test,0) = i - 1
		end if
	loop until i = imagenum
	
	if int(rows_test) > int(rows) then
		OK = false 
		x_Breite= x_Breite + 1
	end if
loop until OK

Faktor = y_row / x_Breite

'Breite kontrollieren, Zeilenhhe ermitteln und max. Anzahl der Rahmen
i = 0 : col = 1 : MaxBreite = 0 : AnzR = 0
do while i < imagenum
	'Breitentest, ggf. Korektur x
	n = i :	BildH = 0 : BildB = 0 : Anzahl = 0 : MaxHoehe = 0
	do while n < Row(col,0) + 1 'and n < imagenum - 1	'#####
		BildH = FF_GetImageFileHeight(FileArray(n))
		if BildH >= MaxHoehe then MaxHoehe = BildH
		BildB =  BildB + Faktor * FF_GetImageFileWidth(FileArray(n))
		if BildB >= MaxBreite then 
			AnzR = Anzahl
			MaxBreite = BildB
		end if
		n = n + 1
		Anzahl = Anzahl + 1
	loop
	Row(col,1) = MaxHoehe
	i = Row(col,0) + 1
	col = col + 1
loop

'Endgltigen Faktor bestimmen
if Endrahmen = 1 and flagGPS = 0 then
	Faktor = (y_row - AnzR * rahmen - 2 * rahmen) / x_Breite
else
	Faktor = (y_row - AnzR * rahmen) / x_Breite
end if

'Collagegre bestimmen
Hoehe_Test = 0
for i = 1 to rows
	Row(i,1) = Faktor * Row(i,1)
	Hoehe_Test = Hoehe_Test + Row(i,1)
next
if Endrahmen = 1 and flagGPS = 0 then
	x_Breite = y_row - 2 * rahmen
else
	x_Breite = y_row
end if

y_Hoehe = Hoehe_Test + (rows * 1 -1) * rahmen
if rows = 1 then Ky = 0 else Ky = .5

'Msgbox "Collagebreite = " & x_Breite & " / Collagehhe = " & y_Hoehe
call NeuesBild (x_Breite +.5,Y_Hoehe +Ky)

'Bilder einfgen
i = 0 : col = 1 : yStart = 0
do while i < imagenum

	'Anordnung links, mittig oder rechts
	n = i :	BildB = 0
	do while n < Row(col,0) + 1
		BildB =  BildB + Faktor * FF_GetImageFileWidth(FileArray(n)) + rahmen
		n = n + 1
	loop
	Diff = x_Breite - BildB + rahmen

	select case Anordnung
		Case "Links"
			xStart = 0
		Case "Mitte"
			xStart = Diff / 2
		Case "Rechts"
			xStart = Diff
	case else
	end select
	
	'Bild einfgen
	do while i < Row(col,0) + 1
		FF_LoadImage FileArray(i)
		
		BildH = Faktor * FF_GetImageHeight
		diff = (Row(col,1)-BildH)/2
		BildB =  Faktor * FF_GetImageWidth
		
'Msgbox 	"Collagebreite = " & x_Breite & " / Collagehhe = " & y_Hoehe & " / Bild = " & i+1 & " / diff = " & diff & vbNewline & _
'		"Startx = " & xStart & " / Starty = " & yStart & " / B-Breite = " & BildB & " / B-Hhe = " & BildH
		
		'Hhentest, ggf Korrektur y
		Ky = y_Hoehe - yStart - BildH
		if Ky < 0 then
			Ky = round(abs(Ky) + .5)
			BildH = BildH - Ky
		end if
		
		if flagNumm = 1 then call Nummerierung (i,BildB,BildH)
		
on error resume next
		FF_Miximage xStart,yStart+diff,BildB,BildH,255
				if err.number > 0 then
			msgbox	"Diese Bilderanordnung funktioniert leider nicht." & vbNewLine & _
					"Bitte ndern und dann nochmal versuchen!",vbCritical,"Abbruch"
			Abbruch = true
			exit sub
		end if
on error goto 0

		xStart = xStart + BildB + rahmen
		FF_SetControl "Collage+","Fortschritt",(i+1)/imagenum * 100
		i = i + 1
	loop
	yStart = yStart + (Row(col,1) + rahmen)
	col = col + 1
	
loop

'Collage anzeigen
FF_PopImage

'Endrahmen
if Endrahmen = 1 and flagGPS = 0 then FF_ExtendCanvas rahmen,rahmen,rahmen,rahmen,FarbWert(0),FarbWert(1),FarbWert(2)

End Sub
'---------------------------------------------------------------------
Sub SonderCollage (Anpassung)
'alle Bilder werden grenproportional untereinander angeordnet
'Anpassung = false -> bei Zeilenanzahl = 0 alle Bilder ohne Grennderung 
'Anpassung = true  -> bei 'ohne Hhennormierung' und rows = imagemnum alle Bilder angepasst an Collagebreite

Dim i,x,y,x_Breite,y_Hoehe,Diff,B,H,xStart,yStart,Ky,Faktor

for i = 0 to imagenum -1
	x = FF_GetImageFileWidth(FileArray(i))
	if x > x_Breite then x_Breite = x			'max. Breite
	y = y + FF_GetImageFileHeight(FileArray(i))	'Gesamthhe
next

if Anpassung then
	if Endrahmen = 1 and flagGPS = 0 then
		Faktor = (y_row - 2 * rahmen) / x_Breite
		x_Breite = y_row - 2 * rahmen
	else
		Faktor = y_row / x_Breite
		x_Breite = y_row
	end if
	y_Hoehe = (y + rahmen * (imagenum -1)) * Faktor
else
	y_Hoehe = y
	Faktor = 1
end if

'Msgbox "Collagebreite = " & x_Breite & " / Collagehhe = " & y_Hoehe
call NeuesBild (x_Breite +.5,Y_Hoehe +Ky)

'Bilder einfgen
for i = 0 to imagenum - 1
	
	FF_LoadImage FileArray(i)
	B = FF_GetImageWidth * Faktor
	H = FF_GetImageHeight * Faktor
	
	'Anordnung links, mittig oder rechts
	Diff = x_Breite - B
	select case Anordnung
		Case "Links"
			xStart = 0
		Case "Mitte"
			xStart = Diff / 2
		Case "Rechts"
			xStart = Diff
	case else
	end select
	
	'Bild einfgen
		
	'Hhentest, ggf Korrektur H
	Ky = y_Hoehe - yStart - H
	if Ky < 0 then
		Ky = round(abs(Ky) + .5)
		H = H - Ky
	end if

	if flagNumm = 1 then call Nummerierung (i,B,H)
	
on error resume next
	FF_Miximage xStart,yStart,B,H,255
		if err.number > 0 then
			msgbox	"Diese Bilderanordnung funktioniert leider nicht." & vbNewLine & _
					"Bitte ndern und dann nochmal versuchen!",vbCritical,"Abbruch"
			Abbruch = true
			exit sub
		end if
on error goto 0

	yStart = yStart + H + rahmen
	
	FF_SetControl "Collage+","Fortschritt",(i+1)/imagenum * 100
next

'Collage anzeigen
FF_PopImage

'Endrahmen
if Endrahmen = 1 and flagGPS = 0 then FF_ExtendCanvas rahmen,rahmen,rahmen,rahmen,FarbWert(0),FarbWert(1),FarbWert(2)

End Sub
'---------------------------------------------------------------------
Sub NeuesBild (BBreite,BHoehe)
'Neues Bild generieren
on error resume next

FF_NewImage BBreite,BHoehe, color
if Err.Number > 0 then 
	if Err.Number = 2003 then
		msgbox 	"Die max. zulssige Gre der Collage wird berschritten!" & vbNewLine & _
				"Bitte die Einstellungen so ndern, dass die Collage kleiner wird.",vbExclamation,"Hinweis"
	else
		msgbox	"Es ist ein leider ein unbekannter Fehler aufgetreten!" & vbNewLine & _
				"Bitte die Collageerstellung mit anderen Einstellungen probieren.",vbExclamation,"Hinweis"
	end if
	Abbruch = true
	exit sub
end if

FF_PushImage

if Err.Number > 0 then
		msgbox	"Es ist ein leider ein unbekannter Fehler aufgetreten!" & vbNewLine & _
				"Wahrscheinlich handelt es sich um Speichermangel." & vbNewLine & _
				"Am besten starten Sie ganz neu und probieren es dann nochmal.",vbExclamation,"Hinweis"
	Abbruch = true
	exit sub
end if

on error goto 0

End Sub
'---------------------------------------------------------------------
Sub RegistryLesen
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel
Dim Liste,OK

'### Werte auslesen

'Auswahl selektierter Bilder
flagCompAnsicht_All = FF_GetProfile(RegSchluessel,"flagCompAnsicht_All")
flagCompAnsicht = FF_GetProfile(RegSchluessel,"flagCompAnsicht")
flagAktListe_All = FF_GetProfile(RegSchluessel,"flagAktListe_All")
flagAktListe = FF_GetProfile(RegSchluessel,"flagAktListe")
if flagCompAnsicht_All = "" then
	flagCompAnsicht_All = 0
	flagCompAnsicht = 1
	flagAktListe_All = 0
	flagAktListe = 0
end if

'Bildverteilung
flagBH = FF_GetProfile(RegSchluessel,"flagBH")	'Vorgabe: 1 = Bilderhhe / 0 = Collagebreite
if flagBH = "" then flagBH = 1
flagOHN = FF_GetProfile(RegSchluessel,"flagOHN")'bei Vorgabe Collagebreite: ohne Hhennormierung
if flagOHN = "" then flagOHN = 0
y_row = FF_GetProfile(RegSchluessel,"y_row")	'Bilderhhe bzw. Collagebreite
if y_row = "" then y_row = 1000
rows = FF_GetProfile(RegSchluessel,"rows")		'Zeilenanzahl
if rows = "" then rows = 1
rows = rows *1

'Bildanordnung
Anordnung = FF_GetProfile(RegSchluessel,"Anordnung")	'Anordnung links, mittig oder rechts
if Anordnung = "" then Anordnung = "Links"

'Rahmen
rahmen = FF_GetProfile(RegSchluessel,"rahmen")	'Rahmenbreite
if rahmen = "" then rahmen = 20
Farbe = FF_GetProfile(RegSchluessel,"color")	'Rahmenfarbe
if Farbe = "" then Farbe = "000 000 000"
Endrahmen = FF_GetProfile(RegSchluessel,"Endrahmen")	'Endrahmen zeichnen
if Endrahmen = "" then Endrahmen = 1

'Bildnummerierung
flagNumm = FF_GetProfile(RegSchluessel,"flagNumm")
if flagNumm = "" then flagNumm = 0

'Formatierung
flagFormat = FF_GetProfile(RegSchluessel,"flagFormat")
if flagFormat = "" then flagFormat = 0

'Geobildaufruf
flagGPS = FF_GetProfile(RegSchluessel,"flagGPS")
if flagGPS = "" then flagGPS = 0

'### Schriftparameter
NummXminus = FF_GetProfile(RegSchluessel,"NummXminus")
if NummXminus = "" then NummXminus = s_NummXminus

NummYminus = FF_GetProfile(RegSchluessel,"NummYminus")
if NummYminus = "" then NummYminus = s_NummYminus

NummHoehe = FF_GetProfile(RegSchluessel,"NummHoehe")
if NummHoehe = "" then NummHoehe = s_NummHoehe

NummStaerke = FF_GetProfile(RegSchluessel,"NummStaerke")
if NummStaerke = "" then NummStaerke = s_NummStaerke

NummSchrift = FF_GetProfile(RegSchluessel,"NummSchrift")
if NummSchrift = "" then NummSchrift = s_NummSchrift

NummFarbe_string = FF_GetProfile(RegSchluessel,"NummFarbe_string")
if NummFarbe_string = "" then NummFarbe_string = s_NummFarbe_string
NummFarbe_Array = split(NummFarbe_string," ")
NummFarbe = NummFarbe_Array(0) + NummFarbe_Array(1) * (2^8) + NummFarbe_Array(2) * (2^16)

flagBuchstaben = FF_GetProfile(RegSchluessel,"flagBuchstaben")
if flagBuchstaben = "" then flagBuchstaben = s_flagBuchstaben

'Anordnung Collage zu Geobild
C_Anordnung = FF_GetProfile(RegSchluessel,"C_Anordnung")
if C_Anordnung = "" then C_Anordnung = "Rechts"

flagGeoAnpassung = FF_GetProfile(RegSchluessel,"flagGeoAnpassung")
if flagGeoAnpassung = "" then flagGeoAnpassung = 0


'### Werte eintragen

'Auswahl selektierter Bilder
FF_SetControl "Collage+","flagCompAnsicht_All",flagCompAnsicht_All
FF_SetControl "Collage+","flagCompAnsicht",flagCompAnsicht
FF_SetControl "Collage+","flagAktListe_All",flagAktListe_All
FF_SetControl "Collage+","flagAktListe",flagAktListe

'Bildverteilung
if flagBH = 1 then
	FF_SetControl "Collage+","flagBH",1
else
	FF_SetControl "Collage+","flagCB",1
	if flagOHN = 1 then FF_SetControl "Collage+","flagOHN",1
end if
FF_SetControl "Collage+","y_row",y_row
FF_SetControl "Collage+","|",rows

'Bildanordnung
select case Anordnung
	Case "Links"
		FF_SetControl "Collage+","flagLinks",1
	Case "Mitte"
		FF_SetControl "Collage+","flagMitte",1
	Case "Rechts"
		FF_SetControl "Collage+","flagRechts",1
Case else
End select

'Rahmen
FF_SetControl "Collage+","rahmen",rahmen
FF_SetControl "Collage+","color",Farbe
FF_SetControl "Collage+","Endrahmen",Endrahmen

'Bildnummereirung
FF_SetControl "Collage+","flagNumm",flagNumm

'Formatierung
FF_SetControl "Collage+","flagFormat",flagFormat

'Geobildaufruf
FF_SetControl "Collage+","flagGPS",flagGPS

End Sub
'---------------------------------------------------------------------
Sub RegistrySchreiben
'Schlsselname = HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\ & RegSchluessel

'Werte auslesen
call WerteAuslesen

'Werte schreiben
FF_WriteProfile RegSchluessel,"flagCompAnsicht_All",flagCompAnsicht_All
FF_WriteProfile RegSchluessel,"flagCompAnsicht",flagCompAnsicht
FF_WriteProfile RegSchluessel,"flagAktListe_All",flagAktListe_All
FF_WriteProfile RegSchluessel,"flagAktListe",flagAktListe

FF_WriteProfile RegSchluessel,"flagBH",flagBH
FF_WriteProfile RegSchluessel,"flagOHN",flagOHN
FF_WriteProfile RegSchluessel,"y_row",y_row
FF_WriteProfile RegSchluessel,"rows",rows

FF_WriteProfile RegSchluessel,"Anordnung",Anordnung

FF_WriteProfile RegSchluessel,"rahmen",rahmen
FF_WriteProfile RegSchluessel,"color",Farbe
FF_WriteProfile RegSchluessel,"Endrahmen",Endrahmen

FF_WriteProfile RegSchluessel,"flagNumm",flagNumm
FF_WriteProfile RegSchluessel,"flagFormat",flagFormat

FF_WriteProfile RegSchluessel,"flagGPS",flagGPS

'### Schriftparameter
FF_WriteProfile RegSchluessel,"NummXminus",NummXminus
FF_WriteProfile RegSchluessel,"NummYminus",NummYminus
FF_WriteProfile RegSchluessel,"NummHoehe",NummHoehe
FF_WriteProfile RegSchluessel,"NummStaerke",NummStaerke
FF_WriteProfile RegSchluessel,"NummSchrift",NummSchrift
FF_WriteProfile RegSchluessel,"NummFarbe_string",NummFarbe_string
FF_WriteProfile RegSchluessel,"flagBuchstaben",flagBuchstaben

End Sub
'---------------------------------------------------------------------
Sub KurzbeschreibungAnzeigen

Dim Taste
Dim Breite	: Breite = LaengeMax * 2.6 + 15
const Hoehe = 180

const ES_READONLY = 2048
const WS_VSCROLL = 2097152

FF_AddDialog "Kurzbeschreibung",Breite,Hoehe
FF_AddControl "Kurzbeschreibung","Beschreibung","EDIT",0,0,Breite,Hoehe-20
FF_SetControlStyle "Kurzbeschreibung","Beschreibung", ES_READONLY + WS_VSCROLL
FF_AddControl "Kurzbeschreibung","OK","BUTTON",Breite/2-15,Hoehe-15,30,10

FF_SetControl "Kurzbeschreibung","Beschreibung",Kurzbeschreibung

do
	Taste = FF_ShowDialog("Kurzbeschreibung")
	if Taste = "CANCEL" or Taste = "OK" then exit do
loop
call FF_CloseDialog("Kurzbeschreibung")

End Sub
'------------------------------------------------------------------------
Sub KurzbeschreibungLesen
on error resume next
Const ForReading = 1
Dim Skript, Anfang, Ende, Zeile

Set Skript = objFS.OpenTextFile(FF_GetScriptPath & "\" & SkriptName, ForReading, False)

if err.number = 53 then
	msgbox "Wahrscheinlich wurde der Originalskriptname " & """" & SkriptName & """" & " abgendert." & vbNewLine & _
		   "Die Kurzbeschreibung kann daher nicht angezeigt werden.",vbExclamation,"Meldung"
	Abbruch = True
	exit sub
end if

Do While Skript.AtEndOfStream <> True
	Zeile = Skript.ReadLine
	
	if instr(Zeile,"** Ende Kurzbeschreibung") > 0 then Ende = true
	if Ende then exit do
	
	if Anfang then Kurzbeschreibung = Kurzbeschreibung & mid(Zeile,2) & vbNewLine
	if len(Zeile)-1 > LaengeMax then LaengeMax = len(Zeile)-1
	
	if instr(Zeile,"** Start Kurzbeschreibung") > 0 then Anfang = true
	
Loop
	
if Anfang and Ende then KBvorhanden = true
Skript.Close

End Sub
'------------------------------------------------------------------------
Sub KillSkript
'Skript mit allen Komponenten entfernen

Dim SPfad

'### FixFotoScript.ini bereinigen
TempFile = FF_GetFFPathEx(1) & "\FixFotoScript.ini"
if objFS.FileExists(TempFile) then
	call IniBereinigung
	if Abbruch then exit sub
else
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht gefunden werden." & vbNewLine & _
			"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	exit sub
end if

'### zip-Archiv auf Wunsch sichern, dann lschen
TempFile = FF_GetScriptPath & "\" & objFS.GetBaseName(Skriptname) & ".zip"
if objFS.FileExists(TempFile) then
	Antwort = msgbox("Soll das Archiv " & objFS.GetBaseName(Skriptname) & ".zip" & _
			 " gesichert werden?",vbYesNo + vbQuestion,"Sicherheitskopie")
	if Antwort = vbYes then
		SPfad = FF_EnterPath(true,"Wo soll die Sicherheitskopie angelegt werden?")
		if SPfad = "" then
			msgbox "Das Lschen des Skripts wird abgebrochen!",vbExclamation,"Hinweis"
			exit sub
		end if
		SPfad = SPfad & "\" & objFS.GetBaseName(Skriptname) & ".zip"
		objFS.CopyFile Tempfile, SPfad, true
	end if
	objFS.DeleteFile TempFile,true
end if

'### Skriptdatei lschen
TempFile = FF_GetScriptPath & "\" & Skriptname
objFS.DeleteFile TempFile,true

'### evtl. beigepackte bzw. erzeugte Dateien und Ordner lschen
'TempFile = FF_GetScriptPath & "\Beipack.txt"		'Dateibeispiel
'if objFS.FileExists(TempFile) then objFS.DeleteFile TempFile,true

TempFile = FF_GetScriptPath & "\MeckiScript\Collage+"	'Dokuordner
if objFS. FolderExists (TempFile) then objFS. DeleteFolder TempFile,true

'### Registry-Daten lschen
TempFile = "HKEY_CURRENT_USER\Software\Joachim Koopmann Software\FixFoto\Script\" & RegSchluessel & "\"
WshShell.RegDelete(TempFile)

'### Fertigmeldung
msgbox "Nach Durchfhrung der 'Automatischen Skriptkonfiguration' ist das Skript" & vbNewLine & _
		Skriptname & " mit allen Komponenten gelscht!",vbExclamation,"Hinweis"
End Sub
'------------------------------------------------------------------------
Sub IniBereinigung
'FixFotoScript.ini - Bereinigung

Dim Zeile, zNr,Anfang, Ende, DateiTmp, ZielZeile, tmpString
DateiTmp =  FF_GetFFPathEx(1) & "\FixFotoScript.tmp"

'### Wo befindet sich der Eintrag zum Skript?
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if tmpString = "[Script]" then Anfang = zNr
	if tmpString = "File=.\" & Skriptname then
		Ende = zNr
		exit do	
	end if
loop 
Zeile.Close

if Ende <= Anfang then
	msgbox 	"Die Datei FixFotoScript.ini konnte nicht bereinigt werden." & vbNewLine & _
		"Der Lschvorgang wird abgebrochen!",vbExclamation,"Hinweis"
	Abbruch = true
	exit sub
end if

'### Zeilen ohne skriptbezogene Zeilen in DateiTmp bertragen
Set Zeile = objFS.OpenTextFile(TempFile, ForReading)
Set ZielZeile  = objFS.CreateTextFile(DateiTmp, True)

zNr = 0
do Until Zeile.AtEndOfStream
	tmpString = Zeile.ReadLine
	zNr = zNr + 1
	if zNr < Anfang or zNr > Ende then
		ZielZeile.WriteLine tmpString
	end if
loop 

Zeile.Close
ZielZeile.Close

'### Umkopieren von DateiTmp nach FixFotoScript.ini (TempFile)
objFS.CopyFile DateiTmp, TempFile, True
objFS.DeleteFile (DateiTmp)

End Sub
'-------------------------------------------------------------------------
Sub Nummerierung(Nummer,BBreite,BHoehe)
Dim xStart,yStart,Text,TL,TH

if flagGPS = 1 and flagBuchstaben = 0 then
'if true and flagBuchstaben = 0 then
	if Nummer < 9 then
		Text = Nummer + 1
	elseif	Nummer > 34 then
		Text = Nummer - 25
	else
		Text = chr(Nummer + 56)
	end if
else
	if flagBuchstaben = 1 and Nummer < 26 then
		Text = chr(Nummer + 65)
	elseif flagBuchstaben = 1 and Nummer > 25 then
		Text = Nummer - 25
	else
		Text = Nummer + 1
	end if
end if

TL = FF_GetTextWidth(Text,NummHoehe,NummStaerke,false,false,NummSchrift)
TH = FF_GetTextHeight(Text,NummHoehe,NummStaerke,false,false,NummSchrift)

xStart = BBreite - NummXminus - TL
yStart = BHoehe - NummYminus - TH

FF_HQScale BBreite,BHoehe,false
FF_DrawText Text,xStart,yStart,NummHoehe,0,NummStaerke,false,false,NummSchrift,NummFarbe

End Sub
'-------------------------------------------------------------------------
Sub Schriftparameter

'** Start Dialog Schriftparameter **
FF_AddDialog "Schriftparameter",179,97
FF_AddControl "Schriftparameter","Abstand des Textendes vom rechten Rand","STATIC",6,6,112,10
FF_AddControl "Schriftparameter","NummXminus","SLEDIT",123,5,25,10
FF_SetControlStyle "Schriftparameter","NummXminus",8193
FF_AddControl "Schriftparameter","px","STATIC",150,5,10,10
FF_AddControl "Schriftparameter","Abstand der Textgrundlinie vom unteren Rand","STATIC",6,18,112,10
FF_AddControl "Schriftparameter","NummYminus","SLEDIT",123,18,25,10
FF_SetControlStyle "Schriftparameter","NummYminus",8193
FF_AddControl "Schriftparameter","px|","STATIC",150,18,10,10
FF_AddControl "Schriftparameter","Schrifthhe","STATIC",6,30,32,10
FF_AddControl "Schriftparameter","NummHoehe","SLEDIT",43,30,25,10
FF_SetControlStyle "Schriftparameter","NummHoehe",8193
FF_AddControl "Schriftparameter","px||","STATIC",70,30,10,10
FF_AddControl "Schriftparameter","Schriftfarbe","STATIC",89,30,32,10
FF_AddControl "Schriftparameter","NummFarbe","COLOR",123,31,25,10
FF_AddControl "Schriftparameter","Schriftstrke","STATIC",6,42,32,10
FF_AddControl "Schriftparameter","NummStaerke","SLEDIT",43,42,25,10
FF_SetControlStyle "Schriftparameter","NummStaerke",8193
FF_AddControl "Schriftparameter","(Wert 1 bis 1000; 400 = normal)","STATIC",70,42,84,10
FF_AddControl "Schriftparameter","Schriftart","STATIC",6,54,32,10
FF_AddControl "Schriftparameter","NummSchrift","FONT",43,54,105,10
FF_AddControl "Schriftparameter","flagBuchstaben","BOOL",18,68,8,8
FF_AddControl "Schriftparameter","Grobuchstaben (A - Z ) statt Zahlen, dann 1, 2 usw.","STATIC",36,67,129,10
FF_AddControl "Schriftparameter","Standard","BUTTON",7,82,33,11
FF_AddControl "Schriftparameter","Abbrechen","BUTTON",78,82,33,11
FF_AddControl "Schriftparameter","bernehmen","BUTTON",116,82,38,11
'** End Dialog Schriftparameter **

FF_SetControl "Schriftparameter","NummXminus",NummXminus
FF_SetControl "Schriftparameter","NummYminus",NummYminus
FF_SetControl "Schriftparameter","NummHoehe",NummHoehe
FF_SetControl "Schriftparameter","NummStaerke",NummStaerke
FF_SetControl "Schriftparameter","NummSchrift",NummSchrift
FF_SetControl "Schriftparameter","NummFarbe",NummFarbe_string
FF_SetControl "Schriftparameter","flagBuchstaben",flagBuchstaben

do
	Select Case FF_ShowDialog ("Schriftparameter")
	Case "Standard"
		FF_SetControl "Schriftparameter","NummXminus",s_NummXminus
		FF_SetControl "Schriftparameter","NummYminus",s_NummYminus
		FF_SetControl "Schriftparameter","NummHoehe",s_NummHoehe
		FF_SetControl "Schriftparameter","NummStaerke",s_NummStaerke
		FF_SetControl "Schriftparameter","NummSchrift",s_NummSchrift
		FF_SetControl "Schriftparameter","NummFarbe",s_NummFarbe_string
		FF_SetControl "Schriftparameter","flagBuchstaben",s_flagBuchstaben
	Case "bernehmen"
		'Werte
		NummXminus = FF_GetControl("Schriftparameter","NummXminus")
		NummYminus = FF_GetControl("Schriftparameter","NummYminus")
		NummHoehe = FF_GetControl("Schriftparameter","NummHoehe")
		NummStaerke = FF_GetControl("Schriftparameter","NummStaerke")		
		NummSchrift = FF_GetControl("Schriftparameter","NummSchrift")
		NummFarbe_string = FF_GetControl("Schriftparameter","NummFarbe")
		NummFarbe_Array = split(NummFarbe_string," ")
		NummFarbe = NummFarbe_Array(0) + NummFarbe_Array(1) * (2^8) + NummFarbe_Array(2) * (2^16)
		flagBuchstaben = FF_GetControl("Schriftparameter","flagBuchstaben")
		'Kontrolle
		if NummXminus = "" then NummXminus = 0 : NummXminus = NummXminus *1
		if NummYminus = "" then NummYminus = 0 : NummYminus = NummYminus *1
		if NummHoehe = "" then NummHoehe = 0   : NummHoehe = NummHoehe *1
			if NummHoehe < 2 then
				Abbruch = true
				msgbox "Die Schrifthhe muss mindestens 2 px betragen!",vbInformation,"Hinweis"
			else
				Abbruch = false
			end if
		if not Abbruch then
		if NummStaerke = "" then NummStaerke = 0 : NummStaerke = NummStaerke *1
			if NummStaerke < 1 then
				Abbruch = true
				msgbox "Die Schriftstrke muss mindestens den Wert 1 haben!",vbInformation,"Hinweis"
			else
				Abbruch = false
			end if
		end if
		
		if not Abbruch then exit do
	Case "CANCEL","Abbrechen"
		Abbruch = true
		exit do
	Case Else
	End Select
loop

FF_CloseDialog ("Schriftparameter")

End Sub
'-------------------------------------------------------------------------
Sub Bilderanzahl
Dim Files,index,Array,element
Dim FileOhneGPS,GPSvorhanden
Abbruch = false : GPSvorhanden = false

	if flagCompAnsicht_All = 1 then
		index = 0
	elseif flagCompAnsicht = 1 then
		index = 1
	elseif flagAktListe_All then
		index = 2
	elseif flagAktListe then
		index = 3
	else
		Abbruch = true
		exit sub
	end if
	Files = FF_GetSelection(index)

Array = split(Files,vbNewLine)	'Bildfilter anwenden
Files = ""
for each element in Array
	if instr(Bildfilter,"." & ucase(objFS.GetExtensionName(element))) > 0 then
		if FF_HasExifInFile(element) then FF_LoadExif element
		if flagGPS = 0 or FF_GetExifTag("Latitude") <> "" then
			GPSvorhanden = true
			Files = Files & element & vbNewLine
		else
			FileOhneGPS = FileOhneGPS & objFS.GetFileName(element) & vbNewLine
		end if
	end if
next
if len(Files) > 2 then Files = left(Files,len(Files)-2)	'vbNewLine am Ende entfernen

if flagGPS = 1 and GPSvorhanden = false then
	msgbox "Da keine Bilder mit Geodaten ausgewhlt sind," & vbNewLine & _
			"kann der Aufruf 'Geobild' nicht aktiviert werden!",vbInformation,"Hinweis"
	flagGPS = 0
	FF_SetControl "Collage+","flagGPS",flagGPS
	FF_WriteProfile RegSchluessel,"flagGPS",flagGPS
	call Bilderanzahl
end if

if Files = "" then
	imagenum = 0
	Abbruch = true
	exit sub
else
	if flagGPS = 1 and FileOhneGPS <> "" and FileOhneGPS <> FileOhneGPSold then
		msgbox "Der Aufruf 'Geobild' ist aktiviert." & vbNewLine & "Die Bilder " & vbNewLine & vbNewLine & _
				FileOhneGPS & vbNewLine & "enthalten keine Geodaten!",vbInformation,"Hinweis"
		FileOhneGPSold = FileOhneGPS
	end if
end if

FileArray = split(Files,vbNewLine)
imagenum = ubound(FileArray) + 1

	if rows = 0 or imagenum = 0 then
		columns = 0
	else
		columns = imagenum \ rows
	end if
	FF_SetControl "Collage+","||",columns

End Sub
'-------------------------------------------------------------------------
Sub Geo_Routine
Dim CBH,CBB,GPSH,GPSB,P
Dim left,right,top,bottom
Dim xstart,ystart,width,height
Dim KombiBild

'erst ab 3.10 B6
'FF_SaveClipboard() 
'FF_LoadClipboard() 

'Collage sichern in der Zwischenablage und dann Geobild-Skript aufrufen
CBH = FF_GetImageHeight
CBB = FF_GetImageWidth
FF_SaveClipboard()

'bergabeparameter, Testbild erzeugen und dann Geobild-Aufruf
if flagCompAnsicht = 1 then		'### Computeransicht
	if flagNumm then
		if flagBuchstaben then	'Bildnummerierung mit Buchstaben
			P = "C1,B"
		else					'Bildnummerierung mit Zahlen
			P = "C1,Z"
		end if
	else						'ohne Bildnummerierung
		P = "C1,"
	end if
else							'### Bilderliste
	if flagNumm then
		if flagBuchstaben then	'Bildnummerierung mit Buchstaben
			P = "C2,B"
		else					'Bildnummerierung mit Zahlen
			P = "C2,Z"
		end if
	else						'ohne Bildnummerierung
		P = "C2,"
	end if
end if

FF_SetParam P
FF_CallScript FF_GetScriptPath & "\geobild.vbs"

'erzeugtes Geobild
if FF_GetParam = "GeoOK" then
	FF_LoadImage FF_GetScriptPath & "\geotemp\geotemp.png"
	GPSH = FF_GetImageHeight
	GPSB = FF_GetImageWidth
else
	msgbox "Es wurde kein Geobild erzeugt!",vbExclamation,"Abbruch"
	Abbruch = true
	FF_LoadClipboard
	exit sub
end if

call Collage_Anordnung

select case C_Anordnung
	case "Links"
		if CBH > GPSH then
			if flagGeoAnpassung = 1 then
				left = CBB + rahmen : right = 0 : top = int((CBH - GPSH) / 2) : bottom = CBH - GPSH - top	'Geobild-Erweiterung
			else
				CBB = GPSH * CBB / CBH
				CBH = GPSH
				left = CBB + rahmen : right = 0 : top = 0 : bottom = 0		'Geobild-Erweiterung
			end if
		else
			left = CBB + rahmen : right = 0 : top = 0 : bottom = 0			'Geobild-Erweiterung
		end if
		xstart = 0 : ystart = 0 : width = CBB : height = CBH				'Collage einfgen
	case "Rechts"
		if CBH > GPSH then
			if flagGeoAnpassung = 1 then
				left = 0 : right = CBB + rahmen : top = int((CBH - GPSH) / 2) : bottom = CBH - GPSH - top	'Geobild-Erweiterung
			else			
				CBB = GPSH * CBB / CBH
				CBH = GPSH	
				left = 0 : right = CBB + rahmen : top = 0 : bottom = 0		'Geobild-Erweiterung
			end if
		else
			left = 0 : right = CBB + rahmen : top = 0 : bottom = 0			'Geobild-Erweiterung
		end if
		xstart = GPSB + rahmen : ystart = 0 : width = CBB : height = CBH	'Collage einfgen
	case "Oben"
		if CBB > GPSB then
			if flagGeoAnpassung = 1 then
				left = int((CBB - GPSB) / 2) : right = CBB - GPSB - left : top = CBH + rahmen : bottom	= 0	'Geobild-Erweiterung
			else
				CBH = GPSB * CBH / CBB
				CBB = GPSB
				left = 0 : right = 0 : top = CBH + rahmen : bottom = 0		'Geobild-Erweiterung
			end if
		else
			left = 0 : right = 0 : top = CBH + rahmen : bottom = 0			'Geobild-Erweiterung
		end if
		xstart = 0 : ystart = 0 : width = CBB : height = CBH				'Collage einfgen
	case "Unten"
		if CBB > GPSB then
			if flagGeoAnpassung = 1 then
				left = int((CBB - GPSB) / 2) : right = CBB - GPSB - left : top = 0 : bottom	= CBH + rahmen	'Geobild-Erweiterung
			else
				CBH = GPSB * CBH / CBB
				CBB = GPSB
				left = 0 : right = 0 : top = 0 : bottom	= CBH + rahmen		'Geobild-Erweiterung
			end if
		else
			left = 0 : right = 0 : top = 0 : bottom	= CBH + rahmen			'Geobild-Erweiterung
		end if
		xstart = 0 : ystart = GPSH + rahmen : width = CBB : height = CBH	'Collage einfgen
case else
end select

'erweitern und in den Stack
FF_ExtendCanvas left,right,top,bottom,FarbWert(0),FarbWert(1),FarbWert(2)
FF_PushImage

'Collage wieder laden und einfgen in das Geobild
FF_LoadClipboard

on error resume next
FF_MixImage xstart,ystart,width,height,255
		if err.number > 0 then
			msgbox	"Diese Bilderanordnung funktioniert leider nicht." & vbNewLine & _
					"Bitte ndern und dann nochmal versuchen!",vbCritical,"Abbruch"
			Abbruch = true
			exit sub
		end if
on error goto 0

'Stack nach oben holen, schrfen und komplettes Bild auf Arbeitsflche laden
FF_PopImage
if Endrahmen = 1 then
	FF_ExtendCanvas rahmen,rahmen,rahmen,rahmen,FarbWert(0),FarbWert(1),FarbWert(2)
end if

if RGB_S then FF_Sharp Schaerfe,true,true,true
if Y_S then FF_YSharp Schaerfe

FF_Reload

End Sub
'-------------------------------------------------------------------------
Function Version_OK(MinVersion)
Dim VersNr

 VersNr=split(MinVersion,".")
 Version_OK=FF_GetMajor * 1000 + FF_GetMinor + FF_GetBuild / 1000 >=_
     		VersNr(0) * 1000 + VersNr(1) + VersNr(2) / 1000

End Function
'-------------------------------------------------------------------------
Sub Collage_Anordnung
Dim Array,element

'** Start Dialog Collage-Anordnung **
FF_AddDialog "Collage-Anordnung",110,76
FF_AddControl "Collage-Anordnung","Anordnung der Collage zum Geobild","STATIC",5,5,87,11
FF_AddControl "Collage-Anordnung","C_Anordnung","COMBO",25,20,40,10
FF_AddControl "Collage-Anordnung","flagGeoAnpassung","BOOL",6,40,8,8
FF_AddControl "Collage-Anordnung","Geobildanpassung an Collagegre","STATIC",16,35,88,10
FF_AddControl "Collage-Anordnung","wenn Collage grer als das Geobild","STATIC",16,43,88,10
FF_AddControl "Collage-Anordnung","bernehmen","BUTTON",54,60,36,11
'** End Dialog Collage-Anordnung **

Array = split(CzuG,"/")
for each element in Array
	FF_SetControl "Collage-Anordnung","C_Anordnung",element
next
FF_SetControl "Collage-Anordnung","C_Anordnung",C_Anordnung

FF_SetControl "Collage-Anordnung","flagGeoAnpassung",flagGeoAnpassung

do
	Select Case FF_ShowDialog ("Collage-Anordnung")
	Case "bernehmen"
		C_Anordnung = FF_GetControl("Collage-Anordnung","C_Anordnung")
		flagGeoAnpassung = FF_GetControl("Collage-Anordnung","flagGeoAnpassung")
		exit do
	Case Else
	End Select
loop

FF_CloseDialog ("Collage-Anordnung")
FF_WriteProfile RegSchluessel,"C_Anordnung",C_Anordnung
FF_WriteProfile RegSchluessel,"flagGeoAnpassung",flagGeoAnpassung

End Sub
'************************************************************************
'Update-Funktion
'************************************************************************
Sub Update
Dim Antwort

call Versionsermittlung_url

if not Abbruch then
	SkriptV_Zahl = Replace(SkriptVersion,".","") *1
	
	if UrlV_Zahl = SkriptV_Zahl then
		msgbox "Die Version " & SkriptVersion & " ist aktuell!",vbInformation,"Versionsmeldung"
	elseif SkriptV_Zahl < UrlV_Zahl then
		Antwort = msgbox("Die Skriptversion " & SkriptVersion & " ist nicht mehr aktuell!" & vbNewLine &_
				"Es steht die Version " & UrlVersion & " zum Download bereit." & vbNewLine & vbNewLine & _
				"Soll die Downloadseite aufgerufen werden?",vbQuestion + vbYesNo,"Versionsmeldung")
		if Antwort = vbYes then
			on error resume next
			WshShell.Run SkriptUrl,1,false
			if err <> 0 then
				msgbox "Die Downloadseite wurde nicht gefunden!",vbExclamation,"Hinweis"
			else
				SkriptEnde = true
			end if
			on error goto 0
		end if
	else
		msgbox 	"Es liegt ein Fehler in den Versionsangaben vor." & vbNewLine &_
				"Die Skriptversion " & SkriptVersion & " ist grer als die auf" & vbNewLine &_
				"der Downloadseite angegebene Version " & UrlVersion & ".",vbInformation,"Fehlermeldung"
	end if
end if

End Sub
'------------------------------------------------------------------------
Sub Versionsermittlung_url

Dim Inhalt,Start,Zeit,pos1,pos2,n
Dim xml, Fehler
Fehler = false

on error resume next
Set xml = CreateObject("Microsoft.XMLHTTP")
xml.Open "Get",SkriptUrl,false
xml.Send

Inhalt = xml.responseText

if err > 0 then
	Fehler = true
else
	'Version suchen und anzeigen
	pos1 = instr(Inhalt,"Version:")
	if pos1 > 0 then
	
		pos2 = instr(pos1 ,Inhalt,"<br")
		if pos2 > 0 then
			UrlVersion = trim(mid(Inhalt,pos1,pos2-pos1))
			'Msgbox "Aktuell ist die " & UrlVersion,vbInformation,"Information"
		else
			Fehler = true
		end if
	else
		Fehler = true
	end if
end if

Set xml = nothing

if Fehler then
	msgbox  "Die Versionsangabe wurde nicht gefunden!" & vbNewLine &_
			"Mglicherweise funktioniert der Internetaufruf nicht." & vbNewLine & vbNewLine & _
			"Am besten nochmal probieren!",vbExclamation,"Fehlermeldung"
	Abbruch = true
	exit sub
end if

'Version als Zahl
pos1 = instr(UrlVersion," ")
if pos1 = 0 then pos1 = 7
UrlVersion = trim(mid(UrlVersion,pos1+1))
UrlV_Zahl = Replace(UrlVersion,".","") *1

End Sub
'------------------------------------------------------------------------
